import React from 'react'
import { loadFeature, defineFeature } from 'jest-cucumber';
// import { render, screen, fireEvent, act, waitForElementToBeRemoved } from "@testing-library/react"
// import App from '../App';
// import { server } from "../mocks/server";
// import { rest } from 'msw'
// import { createMemoryHistory } from 'history'

// mock BrowserRouter (this should probably live somewhere else)
const reactRouterDom = require("react-router-dom")
reactRouterDom.BrowserRouter = ({children}) => <div>{children}</div>
//const Router = reactRouterDom.Router;

const feature = loadFeature('features/iocs/ioc-creation.feature');

defineFeature(feature, (test) => {
  test('Logged in user opens IOC creation form', ({ given, when, then }) => {
    given('the user is on the Home page', () => {

    });

    when('the user clicks the create IOC button', () => {

    });

    then('the user should be presented with a form to create an IOC', () => {

    });
});

  // test('User opens IOC creation form', ({ given, when, then }) => {
  //   given('the user is on the Home page', () => {
  //     const history = createMemoryHistory()
  //     history.push('/home')
  //     render(
  //       <Router history={history}>
  //         <App />
  //       </Router>
  //     )
  //   });

  //   when('the user clicks the create IOC button', async () => {
  //     await screen.findByText(/new ioc/i);
  //     act(() => {
  //       fireEvent.click(screen.getByText(/new ioc/i));
  //     });
  //     await screen.findByTestId("create-dialog-title");
  //   });

  //   then('the user should be presented with a form to create an IOC', async () => {
  //     expect(await screen.findByText(/create new ioc/i)).toBeInTheDocument()
  //   });
  // });

  // test('User submits IOC creation form successfully', ({ given, and, when, then }) => {
  //   var page;
  //   const history = createMemoryHistory()
  //   given('the user has filled out the IOC creation form', async () => {
  //     history.push('/home')
  //     page = render(
  //       <Router history={history}>
  //         <App />
  //       </Router>
  //     )
  //     await screen.findByText(/new ioc/i);
  //     act(() => {
  //       fireEvent.click(screen.getByText(/new ioc/i));
  //     });
  //   });

  //   and('the information is valid', async () => {
  //     await screen.findByTestId("create-dialog-title")
  //     const iocName = page.getByLabelText(/ioc name/i);
  //     act(() => {
  //       fireEvent.change(iocName, {target: {value: 'TEST-IOC-1'}});
  //     });
  //     const git = page.getByLabelText(/git repository/i);
  //     act(() => {
  //       fireEvent.change(git, {target: {value: 'http://test-ioc.git'}});
  //     });
  //   });

  //   when('the user clicks on the Create IOC button', async () => {
  //     server.use(
  //       rest.post("*/iocs", (req, res, ctx) => {
  //           return res(ctx.status(201), ctx.json({
  //             description: "TS2 PSS IOC",
  //             owner: "testuser",
  //             id: 1,
  //             status: null,
  //             createdBy: "testuser",
  //             latestVersion: {
  //               id: 1,
  //               version: 1,
  //               createdBy: "testuser",
  //               createdAt: "2021-08-04T14:35:41.037+00:00",
  //               namingName: "TEST-IOC-1",
  //               sourceUrl: "http://test-ioc.git",
  //               sourceVersion: null
  //             },
  //             activeDeployment: null,
  //             hasLocalCommits: null,
  //             active: true,
  //             dirty: null
  //           })
  //         );
  //       }),
  //       rest.get("*/iocs/:iocId", (req, res, ctx) => {
  //           const { iocId } = req.params
  //           return res(ctx.json({
  //             description: "TS2 PSS IOC",
  //             owner: "testuser",
  //             id: iocId,
  //             status: null,
  //             createdBy: "testuser",
  //             latestVersion: {
  //               id: 1,
  //               version: 1,
  //               createdBy: "testuser",
  //               createdAt: "2021-08-04T14:35:41.037+00:00",
  //               namingName: "TEST-IOC-1",
  //               sourceUrl: "http://test-ioc.git",
  //               sourceVersion: null
  //             },
  //             activeDeployment: null,
  //             hasLocalCommits: null,
  //             active: true,
  //             dirty: null
  //           })
  //         );
  //       })
  //     );

  //     act(() => {
  //       fireEvent.click(screen.getByText('Create'));
  //     });
  //     await waitForElementToBeRemoved(() => screen.getByText('Create'));

  //     history.push('/iocs/1')
  //     render(
  //       <Router history={history}>
  //         <App />
  //       </Router>
  //     )

  //     await screen.findByTestId("ioc-details-container")
  //   });

  //   then('the user should be redirected to the new IOC details page', async () => {
  //     expect(await screen.findByText(/manage deployment/i)).toBeInTheDocument();
  //   });
  // });
});
