import React from "react";
import { IconBadge } from "../common/Badge/IconBadge";
import { DeploymentStatusIcon, DeploymentTypeIcon } from "./DeploymentIcons";

export function DeploymentBadge({ deployment }) {
  return (
    <IconBadge 
      icon={
        <>
          <DeploymentTypeIcon type={deployment.undeployment ? "undeploy" : "deploy"}/>
          <DeploymentStatusIcon status={deployment.status} />
          </>
      }
      title={deployment.iocName} subheader={deployment.host.host || "---"} />
  )
}