import React from 'react';
import { RootContainer } from "../../components/common/Container/RootContainer";
import AccessControl from "../../components/auth/AccessControl";
import { DeploymentsView } from "./DeploymentsView";
import { useGlobalAppBar } from '../../components/navigation/GlobalAppBar/GlobalAppBar';

export function DeploymentsAccessControl() {
  useGlobalAppBar("Deployment log");

  return (
    <RootContainer>
      <AccessControl allowedRoles={["DeploymentToolAdmin", "DeploymentToolIntegrator"]}>
        <DeploymentsView/>
      </AccessControl>
    </RootContainer>
  );
}